<?


//HORIZONTAL GRAD FUNCTION
function horizontal($image, $x, $y, $width, $height, $start_color, $end_color, $vertical = false) {
   if ($width >= $height){
     $steps = $height;
     }
   if ($width <= $height){
      $steps = $width;
    }

  // Loop through the number of steps, and draw a rectangle for each. 
  for($i = 0; $i < $steps; $i++) {

    // Calculate the color. 
    $red = (($end_color[0] - $start_color[0])) * ($i / ($steps - 1)) + $start_color[0];
    $green = (($end_color[1] - $start_color[1])) * ($i / ($steps - 1)) + $start_color[1]; 
    $blue = (($end_color[2] - $start_color[2])) * ($i / ($steps - 1)) + $start_color[2]; 
    $fill_color = imagecolorallocate($image, $red, $green, $blue);

      $rectangle_width = $width/$steps;
      imagefilledrectangle($image, $x + $rectangle_width * $i, $y, $x + ($rectangle_width * $i) + $rectangle_width, $y + $height, $fill_color);

}
}

//VERTICAL GRAD FUNCTION
function vertical($image, $x, $y, $width, $height, $start_color, $end_color) {
   if ($width >= $height){
     $steps = $height;
     }
   if ($width <= $height){
      $steps = $width;
    }

  // Loop through the number of steps, and draw a rectangle for each. 
  for($i = 0; $i < $steps; $i++) {

    // Calculate the color. 
    $red = (($end_color[0] - $start_color[0])) * ($i / ($steps - 1)) + $start_color[0];
    $green = (($end_color[1] - $start_color[1])) * ($i / ($steps - 1)) + $start_color[1]; 
    $blue = (($end_color[2] - $start_color[2])) * ($i / ($steps - 1)) + $start_color[2]; 
    $fill_color = imagecolorallocate($image, $red, $green, $blue);

      $rectangle_height = $height/$steps;
      imagefilledrectangle($image, $x, $y + $rectangle_height * $i, $x + $width, $y + ($rectangle_height * $i) + $rectangle_height, $fill_color);
}
}

//RADIAL GRAD FUNCTION
function radial($image, $x, $y, $width, $height, $start_color, $end_color) {
   if ($width >= $height){
     $steps = $height;
     }
   if ($width <= $height){
      $steps = $width;
    }
  for($i = $steps - 1; $i >= 0; $i--) {
    $red = (($end_color[0] - $start_color[0]) / ($steps - 1)) * $i + $start_color[0];
    $green = (($end_color[1] - $start_color[1]) / ($steps - 1)) * $i + $start_color[1]; 
    $blue = (($end_color[2] - $start_color[2]) / ($steps - 1)) * $i + $start_color[2]; 
   $fill_color = imagecolorallocate($image, $red, $green, $blue);
    $ellipse_width = $width/$steps * ($i + 1);
    $ellipse_height = $height/$steps * ($i + 1);
    imagefilledellipse($image, $x, $y, $ellipse_width, $ellipse_height, $fill_color);
  }
}
//ANGLE GRADIENT
 function angle($image, $x1, $y1, $x2, $y2, $wdt, $left_color, $right_color) {
   $alpha = atan2($y2-$y1,$x2-$x1);
   $real_wdt = $wdt*sin($alpha);
   $real_hgt = $wdt*cos($alpha);
   $i=0;
   $dy = $real_hgt/$wdt;
   $dx = $real_wdt/$wdt;
   $drgb= 256/$wdt;
   while($i++ < $wdt) {
     
    $color0=($left_color[0]-$right_color[0])/$wdt; 
    $color1=($left_color[1]-$right_color[1])/$wdt; 
    $color2=($left_color[2]-$right_color[2])/$wdt; 
        
        $red=$left_color[0]-floor($i*$color0); 
        $green=$left_color[1]-floor($i*$color1); 
        $blue=$left_color[2]-floor($i*$color2); 
        $col= imagecolorallocate($image, $red, $green, $blue);  

    ImageLine($image, $x1-$i*$dx, $y1+$i*$dy, $x2-$i*$dx, $y2+$i*$dy, $col);
    ImageLine($image, $x1-$i*$dx+1, $y1+$i*$dy, $x2-$i*$dx+1, $y2+$i*$dy,$col);

   }
 } 

function arc($image, $x, $y, $width, $height, $angle_start, $angle_end, $start_color, $end_color) {
   if ($width >= $height){
     $steps = $height;
     }
   if ($width <= $height){
      $steps = $width;
    }
  for($i = $steps - 1; $i >= 0; $i--) {
    $red = (($end_color[0] - $start_color[0]) / ($steps - 1)) * $i + $start_color[0];
    $green = (($end_color[1] - $start_color[1]) / ($steps - 1)) * $i + $start_color[1]; 
    $blue = (($end_color[2] - $start_color[2]) / ($steps - 1)) * $i + $start_color[2]; 
   $fill_color = imagecolorallocate($image, $red, $green, $blue);
    $arc_width = $width/$steps * ($i + 1);
    $arc_height = $height/$steps * ($i + 1);
    imagefilledarc($image, $x, $y, $arc_width, $arc_height,$angle_start,$angle_end, $fill_color, $IMG_ARC_PIE);
  }
}


?>